## mingw-w64-tbb-2022.2.0-1.src.tar.zst

=== src/tbb/CMakeLists.txt ===
# Copyright (c) 2020-2025 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_library(tbb
    address_waiter.cpp
    allocator.cpp
    arena.cpp
    arena_slot.cpp
    concurrent_bounded_queue.cpp
    dynamic_link.cpp
    exception.cpp
    governor.cpp
    global_control.cpp
    itt_notify.cpp
    main.cpp
    market.cpp
    tcm_adaptor.cpp
    misc.cpp
    misc_ex.cpp
    observer_proxy.cpp
    parallel_pipeline.cpp
    private_server.cpp
    profiling.cpp
    rml_tbb.cpp
    rtm_mutex.cpp
    rtm_rw_mutex.cpp
    semaphore.cpp
    small_object_pool.cpp
    task.cpp
    task_dispatcher.cpp
    task_group_context.cpp
    thread_dispatcher.cpp
    thread_request_serializer.cpp
    threading_control.cpp
    version.cpp
    queuing_rw_mutex.cpp)

add_library(TBB::tbb ALIAS tbb)

if (WIN32)
    target_sources(tbb PRIVATE tbb.rc)
    set_target_properties(tbb PROPERTIES OUTPUT_NAME "tbb${TBB_BINARY_VERSION}")
endif()

# TODO: Add statistics.cpp

target_compile_definitions(
    tbb
    PUBLIC
    $<$<CONFIG:DEBUG>:TBB_USE_DEBUG>
    PRIVATE
    __TBB_BUILD
    ${TBB_RESUMABLE_TASKS_USE_THREADS}
    $<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:__TBB_DYNAMIC_LOAD_ENABLED=0>
    $<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:__TBB_SOURCE_DIRECTLY_INCLUDED=1>
    $<$<NOT:$<BOOL:${TBB_VERIFY_DEPENDENCY_SIGNATURE}>>:__TBB_SKIP_DEPENDENCY_SIGNATURE_VERIFICATION=1>
)

if (NOT ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "(armv7-a|aarch64|mips|arm64|riscv)" OR
         "${CMAKE_OSX_ARCHITECTURES}" MATCHES "arm64" OR
         WINDOWS_STORE OR
         TBB_WINDOWS_DRIVER))
    target_compile_definitions(tbb PRIVATE __TBB_USE_ITT_NOTIFY)
endif()

target_include_directories(tbb
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

target_compile_options(tbb
    PRIVATE
    ${TBB_CXX_STD_FLAG} # TODO: consider making it PUBLIC.
    ${TBB_MMD_FLAG}
    ${TBB_DSE_FLAG}
    ${TBB_WARNING_LEVEL}
    ${TBB_WARNING_SUPPRESS}
    ${TBB_LIB_COMPILE_FLAGS}
    ${TBB_COMMON_COMPILE_FLAGS}
)

# Avoid use of target_link_libraries here as it changes /DEF option to \DEF on Windows.
set_target_properties(tbb PROPERTIES
    DEFINE_SYMBOL ""
    VERSION ${TBB_BINARY_VERSION}.${TBB_BINARY_MINOR_VERSION}
    SOVERSION ${TBB_BINARY_VERSION}
)

tbb_handle_ipo(tbb)

if (TBB_DEF_FILE_PREFIX) # If there's no prefix, assume we're using export directives
    set_target_properties(tbb PROPERTIES
        LINK_FLAGS "${TBB_LINK_DEF_FILE_FLAG}\"${CMAKE_CURRENT_SOURCE_DIR}/def/${TBB_DEF_FILE_PREFIX}-tbb.def\""
        LINK_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/def/${TBB_DEF_FILE_PREFIX}-tbb.def"
    )
endif()

# Prefer using target_link_options instead of target_link_libraries to specify link options because
# target_link_libraries may incorrectly handle some options (on Windows, for example).
if (COMMAND target_link_options)
    target_link_options(tbb
        PRIVATE
        ${TBB_LIB_LINK_FLAGS}
        ${TBB_COMMON_LINK_FLAGS}
    )
else()
    target_link_libraries(tbb
        PRIVATE
        ${TBB_LIB_LINK_FLAGS}
        ${TBB_COMMON_LINK_FLAGS}
    )
endif()

target_link_libraries(tbb
    PRIVATE
    Threads::Threads
    ${TBB_LIB_LINK_LIBS}
    ${TBB_COMMON_LINK_LIBS}
)

# Strip debug symbols into a separate .dbg file
if(TBB_LINUX_SEPARATE_DBG)
    if(NOT CMAKE_BUILD_TYPE STREQUAL "release")
        find_program(OBJCOPY_COMMAND objcopy)
        if(NOT OBJCOPY_COMMAND)
            message(WARNING "objcopy command not found in the system")
        else()
            add_custom_command(TARGET tbb POST_BUILD
                COMMAND objcopy --only-keep-debug $<TARGET_FILE:tbb> $<TARGET_FILE:tbb>.dbg
                COMMAND objcopy --strip-debug $<TARGET_FILE:tbb>
                COMMAND objcopy --add-gnu-debuglink=$<TARGET_FILE:tbb>.dbg $<TARGET_FILE:tbb>
                COMMENT "Creating and associating .dbg file with tbb"
            )
        endif()
    else()
        message(WARNING " TBB_LINUX_SEPARATE_DBG flag is not used on release config")
    endif()
endif()

if(TBB_BUILD_APPLE_FRAMEWORKS)
    set_target_properties(tbb PROPERTIES
        FRAMEWORK TRUE
        FRAMEWORK_VERSION ${TBB_BINARY_VERSION}.${TBB_BINARY_MINOR_VERSION}
        XCODE_ATTRIBUTE_PRODUCT_BUNDLE_IDENTIFIER com.intel.tbb
        MACOSX_FRAMEWORK_IDENTIFIER com.intel.tbb
        MACOSX_FRAMEWORK_BUNDLE_VERSION ${TBB_BINARY_VERSION}.${TBB_BINARY_MINOR_VERSION}
        MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${TBB_BINARY_VERSION})
endif()

tbb_install_target(tbb)

if (TBB_INSTALL)
    if (MSVC)
        # Create a copy of target linker file (tbb<ver>[_debug].lib) with legacy name (tbb[_debug].lib)
        # to support previous user experience for linkage.
        install(FILES
                $<TARGET_LINKER_FILE:tbb>
                DESTINATION ${CMAKE_INSTALL_LIBDIR}
                CONFIGURATIONS RelWithDebInfo Release MinSizeRel
                RENAME tbb.lib
                COMPONENT devel
        )

        install(FILES
                $<TARGET_LINKER_FILE:tbb>
                DESTINATION ${CMAKE_INSTALL_LIBDIR}
                CONFIGURATIONS Debug
                RENAME tbb_debug.lib
                COMPONENT devel
        )
    endif()
    if(TBB_LINUX_SEPARATE_DBG)
        install(FILES
                $<TARGET_FILE:tbb>.dbg
                DESTINATION ${CMAKE_INSTALL_LIBDIR}
                COMPONENT devel
        )
    endif()
    set(_tbb_pc_lib_name tbb)

    if (WIN32)
        set(_tbb_pc_lib_name ${_tbb_pc_lib_name}${TBB_BINARY_VERSION})
    endif()

    if (CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(TBB_PC_NAME tbb)
    else()
        set(TBB_PC_NAME tbb32)
    endif()

    set(_prefix_for_pc_file "${CMAKE_INSTALL_PREFIX}")

    if (IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
        set(_libdir_for_pc_file "${CMAKE_INSTALL_LIBDIR}")
    else()
        set(_libdir_for_pc_file "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
    endif()

    if (IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
        set(_includedir_for_pc_file "${CMAKE_INSTALL_INCLUDEDIR}")
    else()
        set(_includedir_for_pc_file "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
    endif()

    configure_file(${PROJECT_SOURCE_DIR}/integration/pkg-config/tbb.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${TBB_PC_NAME}.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TBB_PC_NAME}.pc
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/
            COMPONENT devel)
endif()

if (COMMAND tbb_gen_vars)
    tbb_gen_vars(tbb)
endif()

=== examples/task_arena/fractal/CMakeLists.txt ===
# Copyright (c) 2020-2025 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5.0...3.31.3)

project(fractal CXX)

include(../../common/cmake/common.cmake)

set_common_project_settings(tbb)

add_executable(fractal fractal.cpp main.cpp ) 

add_subdirectory(../../common/gui gui)

target_link_libraries(fractal PUBLIC TBB::tbb Threads::Threads UI_LIB_fractal)
target_compile_options(fractal PRIVATE ${TBB_CXX_STD_FLAG})

set(EXECUTABLE "$<TARGET_FILE:fractal>")
set(ARGS auto)
set(PERF_ARGS auto 1 1000000 silent)
set(LIGHT_ARGS auto 1 1000)

add_execution_target(run_fractal fractal ${EXECUTABLE} "${ARGS}")
add_execution_target(perf_run_fractal fractal ${EXECUTABLE} "${PERF_ARGS}")
add_execution_target(light_test_fractal fractal ${EXECUTABLE} "${LIGHT_ARGS}")

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=oneTBB
pkgbase=mingw-w64-tbb
pkgname=("${MINGW_PACKAGE_PREFIX}-tbb")
pkgver=2022.2.0
pkgrel=1
pkgdesc='oneAPI Threading Building Blocks (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://software.intel.com/en-us/oneapi/onetbb'
msys2_repository_url="https://github.com/uxlfoundation/oneTBB"
msys2_references=(
  "cpe: cpe:2.3:a:intel:threading_building_blocks"
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-hwloc")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/uxlfoundation/oneTBB/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        001-fix-using-TBB-with-Debug-build-type.patch
        002-fix-link-flags-on-mingw.patch
        003-fix-getting-assembler-version-on-mingw.patch)
sha256sums=('f0f78001c8c8edb4bddc3d4c5ee7428d56ae313254158ad1eec49eced57f6a5b'
            '094c556a1087563a3a5810db0fa81aed6432b3a8e91aab9a747e9a55ea262f2a'
            '68e228b4cb2226192ac06d2b73eb4fe33c1ebae18e465d299d4f37da1ea3d9e7'
            'd51db2fc6acbb6022fe1e9b0188d0b5bc7041b9db0905cad8a58d6fde3d1750e')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd ${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-using-TBB-with-Debug-build-type.patch \
    002-fix-link-flags-on-mingw.patch \
    003-fix-getting-assembler-version-on-mingw.patch

  find . -name "*.orig" -exec rm -f {} \;
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CC} == gcc ]]; then
    _extra_config+=("-DTBB_ENABLE_IPO=OFF")
  else
    _extra_config+=("-DTBB_ENABLE_IPO=ON")
  fi

  CXXFLAGS+=" -D_WIN32_WINNT=0x0A00 -DNTDDI_VERSION=0x0A000002"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DTBB_TEST=OFF \
    -DTBB_STRICT=OFF \
    -DBUILD_SHARED_LIBS=ON \
    -S ${_realname}-${pkgver} \
    -B build-${MSYSTEM}

  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
